
// Toolbar
class wxClipsToolBarClass: public wxToolBar
{
 public:
  wxClipsToolBarClass(wxWindow *parent, int x = 0, int y = 0, int w = -1, int h = -1,
           long style = 0, int orientation = wxVERTICAL, int RowsOrColumns = 2, char *name = "toolBar"):
   wxToolBar(parent, x, y, w, h, style, orientation, RowsOrColumns, name)
   {
     wxCanvasDC *dc = GetDC();
     wxStoreThingInTable((long)dc, dc, wxTYPE_DC_CANVAS);
   }
                   
  ~wxClipsToolBarClass()
   {
      wxExtensionFunction func = wxFindExtensionCallback(wxTYPE_TOOLBAR, "OnDelete");
      if (func)
        (* (void (*)(long)) func) ((long)this);

      wxDeleteThingInTable((long)this);
      wxCanvasDC *dc = GetDC();
      wxDeleteThingInTable((long)dc);
   }
   void OnPaint(void);
   Bool OnLeftClick(int toolIndex, Bool toggleDown);
   void OnRightClick(int toolIndex, float x, float y);
   void OnMouseEnter(int toolIndex);
};


// Buttonbar
#ifdef wx_msw
class wxClipsButtonBarClass: public wxButtonBar
#else
class wxClipsButtonBarClass: public wxToolBar
#endif
{
 public:
  wxClipsButtonBarClass(wxWindow *parent, int x = 0, int y = 0, int w = -1, int h = -1,
           long style = 0, int orientation = wxVERTICAL, int RowsOrColumns = 2, char *name = "buttonBar"):
#ifdef wx_msw
   wxButtonBar(parent, x, y, w, h, style, orientation, RowsOrColumns, name)
#else
   wxToolBar(parent, x, y, w, h, style, orientation, RowsOrColumns, name)
#endif
   {
     wxCanvasDC *dc = GetDC();
     wxStoreThingInTable((long)dc, dc, wxTYPE_DC_CANVAS);
   }
                   
  ~wxClipsButtonBarClass()
   {
      wxExtensionFunction func = wxFindExtensionCallback(wxTYPE_BUTTONBAR, "OnDelete");
      if (func)
        (* (void (*)(long)) func) ((long)this);

      wxDeleteThingInTable((long)this);
      wxCanvasDC *dc = GetDC();
      wxDeleteThingInTable((long)dc);
   }
   void OnPaint(void);
   Bool OnLeftClick(int toolIndex, Bool toggleDown);
   void OnRightClick(int toolIndex, float x, float y);
   void OnMouseEnter(int toolIndex);
};



